"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.createResource = void 0;
const react_1 = __importStar(require("react"));
const types_1 = require("../types");
const utils_1 = require("./utils");
const ReactCurrentDispatcher = 
// @ts-ignore
react_1.default.__SECRET_INTERNALS_DO_NOT_USE_OR_YOU_WILL_BE_FIRED
    .ReactCurrentDispatcher;
function readContext(Context) {
    const dispatcher = ReactCurrentDispatcher.current;
    if (dispatcher === null) {
        throw new Error("react-cache: read and preload may only be called from within a " +
            "component's render. They are not supported in event handlers or " +
            "lifecycle methods.");
    }
    return dispatcher.readContext(Context);
}
const CacheContext = react_1.createContext(null);
function getResult(resource, fetch) {
    let error;
    let result;
    try {
        result = fetch();
    }
    catch (e) {
        error = e;
    }
    if (utils_1.isPromise(result)) {
        const thenable = result.catch((error) => {
            if (resource.status === types_1.RESOURCE_PENDING) {
                resource.status = types_1.RESOURCE_REJECTED;
                resource.error = error;
                resource.isLoading = false;
            }
        });
        thenable.then((value) => {
            if (resource.status === types_1.RESOURCE_PENDING) {
                resource.status = types_1.RESOURCE_RESOLVED;
                resource.value = value;
                resource.isLoading = false;
            }
        });
        resource.status = types_1.RESOURCE_PENDING;
        resource.promise = thenable;
        resource.isLoading = true;
        return resource;
    }
    resource.status = types_1.RESOURCE_RESOLVED;
    resource.value = result;
    resource.error = error;
    return resource;
}
function accessResult(resource, fetch) {
    if (resource.status === undefined) {
        const newResult = getResult(resource, fetch);
        return newResult;
    }
    else {
        return resource;
    }
}
function createResource(fetch, initialValue) {
    const resource = {
        status: undefined,
        value: initialValue,
        error: undefined,
        promise: undefined,
        isLoading: false,
        read() {
            // react-concurrent doesn't rely on context, but it may in the
            // future, so we read anyway to prevent access outside of render.
            readContext(CacheContext);
            const result = accessResult(resource, fetch);
            switch (result.status) {
                case types_1.RESOURCE_PENDING: {
                    throw result.promise;
                }
                case types_1.RESOURCE_RESOLVED: {
                    return result.value;
                }
                case types_1.RESOURCE_REJECTED: {
                    throw result.error;
                }
                default:
                    // Should be unreachable
                    return undefined;
            }
        },
        preload() {
            accessResult(resource, fetch);
        },
    };
    return resource;
}
exports.createResource = createResource;
//# sourceMappingURL=index.js.map